﻿# coding=utf-8

#	Copyright (C)  2010 Kontaxis Panagiotis
#    				2008-2009  Luis Falcon,
#	This program is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.

#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.

#	You should have received a copy of the GNU General Public License
#	along with this program.  If not, see <http://www.gnu.org/licenses/>.


from tools.translate import _
from mx import DateTime
from osv import fields, osv
import time
import ir
import datetime
#todo
#add code to route name

class lab_element (osv.osv):
	_name = "hospital.lab.element"
lab_element()

class patient_data (osv.osv):
	_name = "hospital.patient"
patient_data()

class hospital_patient_evaluation (osv.osv):
	_name = "hospital.patient.evaluation"
hospital_patient_evaluation()


class hospital_specialty (osv.osv):
	_name = "hospital.specialty"
	_columns = {
		'name' :fields.char ('Description', size=128, help="ie, Addiction Psychiatry"),
		'code' : fields.char ('Code', size=128, help="ie, ADP"),
	}
	_sql_constraints = [
			('code_uniq', 'unique (name)', 'The medical Specialty code must be unique')]

hospital_specialty ()

class physician (osv.osv):

	# def name_get(self, cr, uid, ids, context={}):
		# if not len(ids):
			# return []
		# rec_name = 'name'
		# res = [(r['id'], r[rec_name][1]) for r in self.read(cr, uid, ids, [rec_name], context)]
		# return res
	_rec_name = 'recname'
	_name = "hospital.physician"
	_description = "Information about the doctor"
	_columns = {
		'name' : fields.many2one ('res.partner','Doctor', domain=[('is_doctor', '=', "1")], help="Doctor Name"),
		'recname' : fields.related('name','name',type="char", string="recname"),
		'institution' : fields.many2one ('res.partner','Institution',domain=[('is_institution', '=', "1")],help="Instituion where she/he works"),
		'code' : fields.char ('ID', size=128, help="MD License ID"),
		'specialty' : fields.many2one ('hospital.specialty','Specialty', help="Specialty Code"),
		'user_id' : fields.many2one('res.users','User ID'),
		'info' : fields.text ('Extra info'),
		}

physician ()

class product_hospital (osv.osv):
	_name = "product.product"
	_inherit = "product.product"
	_columns = {
		'is_medicament' : fields.boolean('Medicament', help="Check if the product is a medicament"),
		'is_vaccine' : fields.boolean('Vaccine', help="Check if the product is a vaccine"),
		'is_lab' : fields.boolean('Is Lab Test'),
		'is_bed' : fields.boolean('Is Bed'),
		'labtype' : fields.selection([
                                ('lab','LAB TEST'),
                                ('image','IMAGING TEST'),
								('other','OTHER TEST'),
                                ], 'Test Type', select=True),
	}
product_hospital ()
class product_category_hospital (osv.osv):
	_name = "product.category"
	_inherit = "product.category"
	_columns = {
		'contains_medicaments' : fields.boolean('Category Holds Medicaments', help="Check if the product category holds medicaments"),
		'contains_labexams' : fields.boolean('Category Holds Lab Exams', help="Check if the product category holds is a vaccine"),
	}
product_category_hospital ()

class insurance (osv.osv):
	_order = 'member_since asc'
	_name = "hospital.insurance"
	_columns = {
		'name' : fields.char ('Number', size=64),
		'partner_id' : fields.many2one ('res.partner','Owner'),
		'company' : fields.many2one ('res.partner','Insurance Company', domain=[('is_insurance', '=', True)]),
		'member_since' : fields.date ('Member since'),
		'member_exp' : fields.date ('Expiration date'),
		'category' : fields.char ('Category', size=64, help="Insurance company plan / category"),
		'type' : fields.selection([
								('state','State'),
								('labor_union','Labor Union / Syndical'),
								('private','Private'),

								], 'Insurance Type', select=True),

		'notes' : fields.text ('Extra Info'),

		}
insurance ()



class partner_patient (osv.osv):
	'''def _get_current_insurance(self, cr, uid, ids, name, arg, context={}):
		result={}
		for partner in self.browse(cr, uid, ids, context=context):
			for ins in partner.insurance:
				result[partner.id] = ins.company.name
			return result'''
	_name = "res.partner"
	_inherit = "res.partner"
	_columns = {
		'date' : fields.date('Partner since',help="Date of activation of the partner or patient"),
		'ref': fields.char('ID Number', size=64),
		'is_patient' : fields.boolean('Patient', help="Check if the partner is a patient",select=2),
		'is_doctor' : fields.boolean('Doctor', help="Check if the partner is a doctor",select=2),
		'is_institution' : fields.boolean ('Institution', help="Check if the partner is a hospital Center",select=2),
		'is_pharmacompany' : fields.boolean ('Pharmaceutical Company', help="Check if the partner is a Pharmaceutical Company",select=2),
		'is_insurance' : fields.boolean ('Insurance', help="Check if the partner is an Insurance",select=2),
		'fathername' : fields.char('Father \'s name', size=128),
		'mothername' : fields.char('Mother \'s name', size=128),
		'insurance' : fields.one2many ('hospital.insurance','partner_id',"Insurance"),
		'afm' : fields.char('Tax Number',size=12),
		'doy' : fields.char('DOY',size=64),
		'adt' : fields.char('Identity Number',size=9),
		#'current_insurance' : fields.function(_get_current_insurance, method=True, type='char', string='retname', size=60),
	}
	_sql_constraints = [
		('ref_uniq', 'unique (ref)', 'The partner or patient code must be unique')
 	]

partner_patient ()

class partner_address_patient (osv.osv):
	_name = "res.partner.address"
	_inherit = "res.partner.address"
	_columns = {
		'region' : fields.char('Region',size=128),	
	}
partner_address_patient ()



#Add the partner relationship field to the contacts.
class partner_patient_address (osv.osv):
	_name = "res.partner.address"
	_inherit = "res.partner.address"
	_columns = {
		'relationship' : fields.char('relationship', size=64),
		'relative_id' : fields.many2one('res.partner','Patient', domain=[('is_patient', '=', True)], help="Patient"),
	}
partner_patient_address ()

class procedure_code (osv.osv):
	def _get_name(self, cr, uid, ids, name, arg, context={}):
		result={}
		for pro in self.browse(cr, uid, ids, context=context):
			result[pro.id] = pro.name +" "+ pro.description
		return result
	_description = "hospital Procedure"
	_name = "hospital.procedure"
	_rec_name = "retname"
	_columns = {
		'retname' : fields.function(_get_name, method=True, type='char', string='Name', size=256),
		'name': fields.char ('ICD-10-PCS Code', size=16,required=True),
		'description' : fields.text ('ICD-10-PCS Long Text', size=256,required=True),
		}

	def name_search(self, cr, uid, name, args=[], operator='ilike', context={}, limit=80):
			args2 = args[:]
			if name:
					args += [('name', operator, name)]
					args2 += [('description', operator, name)]
			ids = self.search(cr, uid, args, limit=limit)
			ids += self.search(cr, uid, args2, limit=limit)
			res = self.name_get(cr, uid, ids, context)
			return res

procedure_code ()



class pathology_category(osv.osv):
	def name_get(self, cr, uid, ids,context={}):
		if not len(ids):
			return []
		reads = self.read(cr, uid, ids, ['name','parent_id','code'], context)
		res = []
		for record in reads:
			#print record['code']
			name = str(record['code']) + " " + record['name']
			if record['parent_id']:
				name = record['parent_id'][1]+' / '+name
			res.append((record['id'], name))
		return res

	def _name_get_fnc(self, cr, uid, ids, args, foo, faa):
		res = self.name_get(cr, uid, ids, args)
		return dict(res)
	def _check_recursion(self, cr, uid, ids):
		level = 100
		while len(ids):
			cr.execute('select distinct parent_id from hospital_pathology_category where id in ('+','.join(map(str,ids))+')')
			ids = filter(None, map(lambda x:x[0], cr.fetchall()))
			if not level:
				return False
			level -= 1
		return True

	_description='Pathology Categories'
	_name = 'hospital.pathology.category'
	_columns = {
		'code': fields.char('ICD-10 Code', size=15, select=True),
		'name': fields.char('Category Title', required=True, size=256),
		'parent_id': fields.many2one('hospital.pathology.category', 'Parent Category', select=True),
		'complete_name': fields.function(_name_get_fnc, string='Title', method=True, type="char"),
		'single_name': fields.function(_name_get_fnc, string='Title', method=True, type="char"),
		'info' : fields.text('Information'),
		'child_ids': fields.one2many('hospital.pathology.category', 'parent_id', 'Child Categories'),
		'pathology_ids': fields.one2many('hospital.pathology', 'category', 'Pathologies'),
		'active' : fields.boolean('Active Category'),
	}
	_constraints = [
		(_check_recursion, _('Error ! You can not create recursive categories.'), ['parent_id'])
	]
	_defaults = {
		'active' : lambda *a: 1,
	}
	_order = 'parent_id,id'

pathology_category()


class pathology (osv.osv):
	def _name_get_f(self, cr, uid, ids, name, arg, context={}):
		result={}
		for pathology in self.browse(cr, uid, ids, context=context):
			result[pathology.id] = str(pathology.code) + ' ' + pathology.name
		return result
	#_rec_name = 'complete_name'
	_order = 'code asc,name asc'
	_name = "hospital.pathology"
	_description = "Pathologies"
	_columns = {
		'name' : fields.char ('Title', size=512, help="Pathology Title", required=True),
		'complete_name': fields.function(_name_get_f, string='Pathology Title', method=True, type="char"),
		'code' : fields.char ('ICD-10 Code', size=5, required=True, help="WHO - International Classification of Diseases Code"),
		'category' : fields.many2one('hospital.pathology.category', 'Category', required=True),
		'chromosome' : fields.char ('Affected Chromosome', size=128, help="Chromosome Number"),
		'protein' : fields.char ('Protein involved', size=128, help="Name of the protein(s) affected"),
		'gene' : fields.char ('Gene', size=128, help="Name of the gene(s) affected"),
		'info' : fields.text ('Extra Info'),
	}

	_sql_constraints = [
		('code_uniq', 'unique (code)', _('The pathology code must be unique'))]


	def name_search(self, cr, uid, name, args=[], operator='ilike', context={}, limit=80):
			args2 = args[:]
			if name:
					args += [('name', operator, name)]
					args2 += [('code', operator, name)]
			ids = self.search(cr, uid, args, limit=limit)
			ids += self.search(cr, uid, args2, limit=limit)
			res = self.name_get(cr, uid, ids, context)
			return res
pathology ()

class drug_route (osv.osv):
	_name = "hospital.drug.route"
	_description = "Administration Route" 
	_columns = {
		'name' : fields.char ('Route',size=64, required=True, translate=True),
		'code' : fields.char ('Route Code',size=32, required=True),
		}
drug_route ()

#add code to type name 

class drug_type (osv.osv):
	_name = "hospital.drug.type"
	_description = "Medicament Type"
	_columns = {
		'name' : fields.char ('Type',size=128, translate=True, select=True ),
		'code' : fields.char ('Type Code',size=32, select=True),
		'route_id': fields.many2one('hospital.drug.route', 'Administration Route', select=True),
		}
drug_type ()

class drug_category (osv.osv):
	def name_get(self, cr, uid, ids, context={}):
		if not len(ids):
			return []
		reads = self.read(cr, uid, ids, ['name','parent_id','number'], context)
		res = []
		for record in reads:
			name = str(record['number']) + " " + record['name']
			if record['parent_id']:
				name = record['parent_id'][1]+' / '+name
			res.append((record['id'], name))
		return res

	def _name_get_fnc(self, cr, uid, ids, args, foo, faa):
		res = self.name_get(cr, uid, ids, args)
		return dict(res)
	def _check_recursion(self, cr, uid, ids):
		level = 100
		while len(ids):
			cr.execute('select distinct parent_id from hospital_drug_category where id in ('+','.join(map(str,ids))+')')
			ids = filter(None, map(lambda x:x[0], cr.fetchall()))
			if not level:
				return False
			level -= 1
		return True
	#_rec_name='complete_name'
	_description='Medicament Categories'		
	_name = "hospital.drug.category"
	_order = 'id,parent_id'
	_columns = {
		'name' : fields.char('Title',size=128, required=True, select=1), #title
		'complete_name': fields.function(_name_get_fnc, string='Name', method=True, type="char"),
		'description' : fields.text('Description'),
		'number' : fields.char('Number', size=5, help="Number of Chapter/Subchapter" ), 
		'parent_id': fields.many2one('hospital.drug.category', 'Parent Category', select=1),
		'child_ids': fields.one2many('hospital.drug.category', 'parent_id', 'Childs Category'),
		'substances_ids' : fields.one2many('hospital.drug.substance', 'category_id', 'Containing Substances'),
		'indications' : fields.text('Indications',select=2),
		'contra_indications' : fields.text('Contra Indications',select=2),
		'adverse_reactions' : fields.text('Adverse Reactions',select=2), 
		'interactions' : fields.text('Interactions',select=2), 
		'dosage' : fields.text('Dosage'), 
		'caution' : fields.text('Caution'),
		'storage' : fields.text('Storage'), 
		'etc' : fields.char('etc',size=64),
		'contains_drugs' : fields.boolean('Contains Substances',select=2),
	}
	_constraints = [
		(_check_recursion, _('Error ! You can not create recursive categories.'), ['parent_id'])
	]

drug_category()

class drug_substance (osv.osv):
	def _get_name(self, cr, uid, ids, name, arg, context={}):
		result={}
		for sub in self.browse(cr, uid, ids, context=context):
			result[sub.id] = sub.name_local if sub.name_local!=False else sub.name_english
		return result
	_name = "hospital.drug.substance"
	_description = "Medicament Substance"
	_rec_name= 'name'
	_columns = {
		'name_english' : fields.char('Name English', size=256, select=True),
		'name_local' : fields.char('Local Name',size=256, select=True),
		'name' : fields.function(_get_name, method=True, type='char', string='Name', size=256),
		'category_id' : fields.many2one('hospital.drug.category','Category', select=True, required=1),
		'annotation' : fields.char('Annotation', size=128, select=2),
		'description' : fields.text('Description'),
		'indications' : fields.text('Indications', select=2),
		'contra_indications' : fields.text('Contra indications', select=2),
		'adverse_reactions' : fields.text('Adverse reactions', select=2),
		'interactions' : fields.text('Interactions', select=2),
		'dosage' : fields.text('Dosage'),
		'caution' : fields.text('Caution'),
		'storage' : fields.text('Storage'),
		'form_content' : fields.text('Form Content'), 
		'etc' : fields.char('Etc', size=256),
		'is_vaccine' : fields.boolean('Is Vaccine'),
		'medicament_ids': fields.one2many('hospital.drug.medicament', 'substance_id', 'Medicaments on this category'),
	}
drug_substance()
class drug_indication (osv.osv):
	_name = "hospital.drug.medicament.indication"
	_description = "Medicament Indication"
	_columns = {
		'code' : fields.char('Code', size=5,select=1),
		'name' : fields.text('Name')
	}
drug_indication()
class drug_restriction (osv.osv):
	_name = "hospital.drug.medicament.restriction"
	_description = "Medicament Restriction"
	_columns = {
		'code' : fields.char('Code', size=5,select=1),
		'name' : fields.text('Name')
	}
drug_restriction()
class drug_recommendation (osv.osv):
	_name = "hospital.drug.medicament.recommendation"
	_description = "Medicament Recommendation"
	_columns = {
		'code' : fields.char('Code', size=5,select=1),
		'name' : fields.text('Name')
	}
drug_recommendation()
class hospital_medicament (osv.osv):
	def _get_categ_id(self, cr, uid, *args):
		cr.execute('select id from product_category where contains_medicaments=True order by id limit 1')
		res = cr.fetchone()
		return res and res[0] or False
	def onchange_drugtype(self, cr, uid, ids, type_id):
		res = self.pool.get('hospital.drug.type').read(cr, uid, type_id)
		#print obj
		result = {'value': {
			'route_id': res['route_id']
			}
		}
		return result

	_name = "hospital.drug.medicament"
	_description = "Medicament"
	_inherits={'product.product':'medicament_id'}
	_columns = {
		'medicament_id': fields.many2one('product.product','Medicament ID',select=1),
		'type_id' : fields.many2one('hospital.drug.type','Type'),
		'route_id' : fields.related('type_id','route_id',type='many2one',relation='hospital.drug.route', string = 'Administration Route'),
		'is_in_formulary' : fields.boolean('Is in Formulary'),
		'wholesale_price' : fields.float('Wholesale Price'),
		'hospital_price' : fields.float('Hospital Price'),
		'content' : fields.char('Content', size=128, select=2),
		'hospack' : fields.char('Packaging', size=128, select=2),
		'substance_id' : fields.many2one('hospital.drug.substance','Medicament Substance'),
		'pharmacompany_id' : fields.many2one('res.partner','Company',domain="[('is_pharmacompany','=','1')]"),
		'indication_ids' : fields.many2many('hospital.drug.medicament.indication', 'hospital_poduct_indication_rel', 'product_id', 'indication_id', 'Indications'),
		'recommendation_ids' : fields.many2many('hospital.drug.medicament.recommendation', 'hospital_poduct_recommendation_rel', 'product_id', 'recommendation_id', 'Recommendations'),
		'restriction_ids' : fields.many2many('hospital.drug.medicament.restriction', 'hospital_poduct_restriction_rel', 'product_id', 'restriction_id', 'Restrictions'),
		'instructions' : fields.text('Instructions'),
	}
	_defaults = {
		'categ_id': _get_categ_id,
	}
hospital_medicament ()

class lab_template (osv.osv):
	def build_form(self, cr, uid, data, context):
		obj2 = self.pool.get('hospital.lab.template')
		res2 = obj2.browse(cr, uid, data['form']['labtemplate_id'])
		categ_id=res2.categ_id.id
		labtype=res2.labtype
		lab_fields={}
		lab_form=""
		if labtype in ('image','other'):
			#print labtype
			lab_form='''<?xml version="1.0"?>
				<form string="%s"><field name="date_analysis" colspan="2" required="1"/><newline/>''' % _('Lab Test')
			lab_fields['date_analysis']={'string': _('Date Analysis'), 'type': 'datetime' }
			lab_form=lab_form+'<field name="image" width="300" height="300" img_width="200" img_height="200" widget="image"/><newline/><field name="file"/></form>' if labtype=='other' \
				else lab_form+'<field name="image" width="300" height="300" img_width="200" img_height="200" widget="image"/></form>'
			lab_fields['image']={'string': _('Image File'), 'type': 'binary' }
			lab_fields['file']={'string': _('File'), 'type': 'binary' }
		if labtype=='lab':
			#print 'categ_id=' + str(categ_id)
			obj = self.pool.get('hospital.lab.holder')
			ids = obj.search(cr, uid, [('labtemplate_id', '=', data['form']['labtemplate_id'])])
			res = obj.browse(cr, uid, ids)
			#print res
			lab_form='''<?xml version="1.0"?>
				<form string="%s">
				<field name="date_analysis" colspan="2" required="1"/><newline/>
				<group col="6" colspan="4">''' % _('Lab Test')
			lab_fields['date_analysis']={'string': 'Date Analysis', 'type': 'datetime', }
			data['cache']={}
			for cur in res:
				data['cache'][int(cur.labelement_id.id)]=cur.sequence
				lab_form = lab_form + '<field name="lab_form%d"/>' % (cur.labelement_id.id,)
				lab_form = lab_form + '<label string="%s"/>' % (cur.labelement_id.units if cur.labelement_id.units else "")
				lab_fields['lab_form%d' % (cur.id,)] = {'string': cur.labelement_id.name, 'type': cur.labelement_id.el_type }
			lab_form = lab_form + '<newline/>'
			for i in range(4):
				lab_form = lab_form + '<field name="extra%d" nolabel="1"/>' % (i,)
				lab_fields['extra%d' % (i,)] = {'string': 'extra', 'type': 'many2one', 'relation':'hospital.lab.element', 'domain':[('category_id','=',categ_id)] }
				st='<field name="extraval%d" nolabel="1" ' % (i,)
				st=st+ 'attrs="{\'readonly\':[(\'extra%d\',\'=\',0)]}"/>' % (i,)
				print st
				lab_form = lab_form + st
				lab_fields['extraval%d' % (i,)] = {'string': 'extraval', 'type': 'char' }
				lab_form = lab_form + '<label string=""/>'
			lab_form = lab_form + '''</group></form>'''
		return lab_form, lab_fields

	def _get_categ_id(self, cr, uid, *args):
		cr.execute('select id from product_category where contains_labexams=True order by id limit 1')
		res = cr.fetchone()
		return res and res[0] or False
	def onchange_exam_id(self, cr, uid, ids, exam_id):
		v={}
		if exam_id:
			tmp = self.pool.get('product.product').read(cr, uid, exam_id,['default_code', 'categ_id','labtype','standard_price'])
			print tmp
			v= {'default_code':tmp['default_code'], 'categ_id':tmp['categ_id'],
			     'labtype':tmp['labtype'], 'standard_price':tmp['standard_price'],
			}
		return {'value': v}
	_name = "hospital.lab.template"
	_description = "Lab Test Template"
	_columns = {
		'name' : fields.related('exam_id','name',type='char',string='Name',select=1),
		'exam_id': fields.many2one('product.product','Exam ID',select=1, domain=[('is_lab','=',1),('type','=','service'),('supply_method','=','produce')]),
		'default_code':fields.related('exam_id','default_code',type='char',size=64,string='Default Code'),
		'categ_id' : fields.related('exam_id','categ_id',type='many2one',relation='product.category',required=1,select=1,string='Category'),
		'labtype' : fields.related('exam_id','labtype',type='selection',selection=[
                                ('lab','LAB TEST'),
                                ('image','IMAGING TEST'),
								('other','OTHER TEST'),
                                ],string='Lab Type'),
		'standard_price' : fields.related('exam_id','standard_price',type='float',string='Standard Price'),
		'holder_ids': fields.one2many('hospital.lab.holder', 'labtemplate_id', 'Lab Holders'),
	}
	'''_defaults = {
		'categ_id': _get_categ_id,
		'is_lab':lambda *a: 1,
		'type':lambda *a: 'service',
		'supply_method':lambda *a: 'produce',
	}'''
lab_template ()
class lab_holder (osv.osv):
	_name = "hospital.lab.holder"
	_order = "sequence asc"
	_columns = {
		'sequence' : fields.integer('Sequence'),
		'labelement_id' : fields.many2one('hospital.lab.element','Lab Element'),
		'labtemplate_id' : fields.many2one('hospital.lab.template','Lab Template'),
	}
lab_holder()

class lab (osv.osv):
	_name = "hospital.lab.test"
	_description = "Lab Test"
	_order = "date_analysis asc"
	_columns = {
		'name' : fields.char ('ID', size=128, help="Lab result ID"),
		'labtemplate_id' : fields.many2one ('hospital.lab.template', 'Test type', help="Lab test type"),
		'labtype' : fields.related('labtemplate_id','labtype',type='char',string='Test Type',readonly=True),
		'categ_id' : fields.related('labtemplate_id','categ_id',type='many2one',relation='product.category',string='Category ID'),
		'patient_id' : fields.many2one ('hospital.patient', 'Patient', required=True, help="Patient",select=1), 
		'pathologist' : fields.many2one ('hospital.physician','Pathologist',help="Pathologist"),
		'requestor' : fields.many2one ('hospital.physician', 'Requestor', help="Doctor who requested the test"),
		'reviewer' : fields.many2one ('hospital.physician', 'Reviewer', help="Doctor who requested the test"),
		'analyzer' : fields.many2one ('hospital.physician', 'Analyzer', help="Doctor who requested the test"),
		'date_request' : fields.datetime ('Date requested'),
		'date_analysis' : fields.datetime ('Date of the Analysis'),
		'date_review' : fields.datetime ('Date of the Review'),
		'results' : fields.text ('Results'),
		'diagnosis' : fields.text ('Diagnosis'),
		'review' : fields.char ('Review',size=256),
		'lablines_ids' : fields.one2many('hospital.lab.line','labtest_id','Lab Lines'),
		'image' : fields.binary('Image'),
		'datafile' : fields.binary('Data File'),
		'state' : fields.selection([('draft','Draft'),('ordered','Ordered and waiting Results'),('results', 'Results Ready'),('reviewed','Reviewed'),('canceled','Canceled')], 'State', size=16, readonly=True),
	}

	_sql_constraints = [
				('id_uniq', 'unique (name)', 'The test ID code must be unique')]
	_defaults = {
		#'ttt':lambda *a: '0',
		#'date_request': lambda *a: DateTime.now(),
		'state': lambda *a: 'draft',
	}
	def onchange_labtest(self, cr, uid, ids,patient_id):
		if not ids:
			raise osv.except_osv(_('Error !'), _('You cannod add Test this way. Use button "Add new Test" instead.'))
		return {'value': {}}
	def case_order(self, cr, uid, ids, date_request={}):
		cases = self.browse(cr, uid, ids)
		cases[0].state # to fill the browse record cache
		obj = self.pool.get('hospital.physician')
		user_ids=obj.search(cr, uid, [('user_id', '=', uid)])
		res = obj.read(cr, uid, user_ids,['id'])
		print res
		self.write(cr, uid, ids, {'state':'ordered','date_request':date_request if date_request else DateTime.now(),'requestor':res[0]['id']})
		obj = self.pool.get('hospital.lab.test').browse(cr, uid, ids)
		labtemplate_id=[tt.labtemplate_id.id for tt in obj][0]
		partner_id=[tt.patient_id for tt in obj][0]

		
		#Diabazw ta holder_ids toy sygkekrimenou template
		obj = self.pool.get('hospital.lab.template')		
		reader=obj.read(cr, uid, labtemplate_id,['holder_ids','labtype'])
		print reader
		holder_ids = reader['holder_ids']
		obj = self.pool.get('hospital.lab.holder').browse(cr, uid, holder_ids)
		sequences=[]
		elements=[]
		for tmp in obj:
			sequences.append(tmp.sequence)
			elements.append(tmp.labelement_id) #edw diabazw ta holder_ids
		#print sequences
		#print elements
		retval=[]
		if 0: #an yparxei idi diegrapse ta trexonta lab lines
			obj=self.pool.get('hospital.lab.line')
			searchid = obj.search(cr, uid, [('labtest_id', '=', ids[0])])
			lines_toremove=obj.read(cr,uid,searchid,['id'])
			torem=[]
			for ch in lines_toremove:
				torem.append(ch['id'])
			self.pool.get('hospital.lab.line').unlink(cr,uid, torem)
			#print lines_toremove
		for i,ch in enumerate(sequences):
			add_dict={'labtest_id': ids[0],
				'sequence': sequences[i],
				'labelement_id': elements[i].id}
			#print add_dict
			labline_id = self.pool.get('hospital.lab.line').create(cr, uid, add_dict)
			t=(ids[0],labline_id,{'labelement_id': int(elements[i].id),'value': u'', 'sequence': sequences[i]})
			retval.append(labline_id)
		#print res
		return True
	def case_result(self, cr, uid, ids, date_analysis={}):
		cases = self.browse(cr, uid, ids)
		cases[0].state # to fill the browse record cache
		obj = self.pool.get('hospital.physician')
		user_ids=obj.search(cr, uid, [('user_id', '=', uid)])
		res = obj.read(cr, uid, user_ids,['id'])
		self.write(cr, uid, ids, {'state':'results','analyzer':res[0]['id']})
		return True
	def case_review(self, cr, uid, ids, *args):
		print 'state'+str(ids)
		cases = self.browse(cr, uid, ids)
		cases[0].state # to fill the browse record cache
		obj = self.pool.get('hospital.physician')
		user_ids=obj.search(cr, uid, [('user_id', '=', uid)])
		res = obj.read(cr, uid, user_ids,['id'])
		self.write(cr, uid, ids, {'state':'reviewed','date_review':DateTime.now(),'reviewer':res[0]['id']})
		return True
	def case_cancel(self, cr, uid, ids, *args):
		print 'state'+str(ids)
		cases = self.browse(cr, uid, ids)
		cases[0].state # to fill the browse record cache
		self.write(cr, uid, ids, {'state':'canceled'})
		return True
lab ()
class lab_line (osv.osv):
	def _get_units(self, cr, uid, ids, name, arg, context={}):
		result={}
		for line in self.browse(cr, uid, ids, context=context):
			result[line.id] = line.labelement_id.units
		return result

	def _get_normalvalues(self, cr, uid, ids, name, arg, context={}):
		prefix= 'm' #'m' for male, 'f' for female
		age= 180 #age in days
		result={}
		for line in self.browse(cr, uid, ids, context=context):
			a = line.labelement_id
			#print a
			dict= {'mper1':a.mper1,'mper2':a.mper2,'mper3':a.mper3,'mper4':a.mper4,'mper5':a.mper5,
				'mper6':a.mper6,'mper7':a.mper7,'mper8':a.mper8,'mper9':a.mper9,'mper10':a.mper10,
				'fper1':a.fper1,'fper2':a.fper2,'fper3':a.fper3,'fper4':a.fper4,'fper5':a.fper5,
				'fper6':a.fper6,'fper7':a.fper7,'fper8':a.fper8,'mper9':a.mper9,'mper10':a.mper10,
				'mper1_low':a.mper1_low,'mper2_low':a.mper2_low,'mper3_low':a.mper3_low,'mper4_low':a.mper4_low,'mper5_low':a.mper5_low,
				'mper6_low':a.mper6_low,'mper7_low':a.mper7_low,'mper8_low':a.mper8_low,'mper9_low':a.mper9_low,'mper10_low':a.mper10_low,
				'mper1_high':a.mper1_high,'mper2_high':a.mper2_high,'mper3_high':a.mper3_high,'mper4_high':a.mper4_high,'mper5_high':a.mper5_high,
				'mper6_high':a.mper6_high,'mper7_high':a.mper7_high,'mper8_high':a.mper8_high,'mper9_high':a.mper9_high,'mper10_high':a.mper10_high,
				'fper1_low':a.fper1_low,'fper2_low':a.fper2_low,'fper3_low':a.fper3_low,'fper4_low':a.fper4_low,'fper5_low':a.fper5_low,
				'fper6_low':a.fper6_low,'fper7_low':a.fper7_low,'fper8_low':a.fper8_low,'fper9_low':a.fper9_low,'fper10_low':a.fper10_low,
				'fper1_high':a.fper1_high,'fper2_high':a.fper2_high,'fper3_high':a.fper3_high,'fper4_high':a.fper4_high,'fper5_high':a.fper5_high,
				'fper6_high':a.fper6_high,'fper7_high':a.fper7_high,'fper8_high':a.fper8_high,'fper9_high':a.fper9_high,'fper10_high':a.fper10_high
				}
			res=[]
			res.append(dict)
			find_period=[i for i in range(10)[1:] if res[0][str(prefix)+'per'+str(i)]<=age<=res[0][str(prefix)+'per'+str(i+1)] and res[0][str(prefix)+'per'+str(i+1)]!=0] #ta anwtata oria twn ilikiwn
			ft=""
			if len(find_period)!=0:
				ft=str(res[0]['mper'+str(find_period[0])+'_low'])+"-"+str(res[0]['mper'+str(find_period[0])+'_high'])
			result[line.id]=ft
		return result
	def _get_notice(self, cr, uid, ids, name, arg, context={}): #notice about lower(L) or higher(H) value from normalvalues interval
		result={}
		for line in self.browse(cr, uid, ids, context=context):
			#print line.normalvalues
			result[line.id] = ''
			if line.normalvalues:
				minmax=line.normalvalues.split('-')
				try:
					if float(line.value)<float(minmax[0]):
						result[line.id] = 'L'
					if float(line.value)>float(minmax[1]):
						result[line.id] = 'H'
				except:
					print 'not float'
		return result
	def onchange_value (self, cr, uid, ids, value,normalvalues=False): #change value's value depending on labelement_id el_type (integer,float,string)
		v={'value':''}
		for cur in self.browse(cr, uid, ids):
			if cur.labelement_id.el_type=='integer':
				try:
					v = {'value':int(float(value))}
				except:
					pass
			if cur.labelement_id.el_type=='float':
				try:
					v = {'value':float(value.replace(',','.'))}
				except:
					pass
			if cur.labelement_id.el_type=='char':
				try:
					v = {'value':value}
				except:
					pass
		#set notice depending on normalvalues
		if normalvalues:
			minmax=normalvalues.split('-')
			try:
				v['notice']=''
				if float(value)<float(minmax[0]):
					v['notice'] = 'L'
				if float(value)>float(minmax[1]):
					v['notice'] = 'H'
			except:
				print 'not float'
		print v
		return {'value': v}	
	def check_element_value(self, cr, uid, ids, parent=None): #constraint about type of value depending on labelement_id el_type (integer,float,string)
		for cur in self.browse(cr, uid, ids):
			if cur.labelement_id.el_type=='integer':
				try:
					a=int(float(cur.value))
				except:
					return 0
			if cur.labelement_id.el_type=='float':
				try:
					a=float(cur.value)
				except:
					return 0
		return 1 #accept
	_name = "hospital.lab.line"
	_description = "Lab Line"
	_order = "sequence asc"
	_columns = {
		'labtest_id' : fields.many2one('hospital.lab.test', 'Lab Test'),
		'sequence' : fields.integer('Index ID'),
		#'categ_id' : fields.related('labtest_id', 'categ_id', type='many2one', relation='product.category', string='Category ID'),
		'labelement_id' : fields.many2one ('hospital.lab.element', 'Lab Element'),
		'value' : fields.char('value',size=128),
		'units' : fields.function(_get_units, method=True, type='char', string='Units', size=60),
		'normalvalues' : fields.function(_get_normalvalues, method=True, type='char', string='Normal Values', size=60),
		'notice' : fields.function(_get_notice, method=True, type='char', string='Notice', size=5),
	}
	_constraints = [
		#(check_element_value, 'Some Lab Elements values must be numeric instead of text', ['value'])
	]
lab_line()

class lab_element (osv.osv):
	#elegxei an oi periodoi einai kata ayksousa seira
	def check_start_days(self, cr, uid, ids, parent=None):
		for cur in self.browse(cr, uid, ids):
			mper=[]
			mper.append([cur.mper1,cur.mper2,cur.mper3,cur.mper4,cur.mper5,cur.mper6,cur.mper7,cur.mper8,cur.mper9])
			mper.append([cur.fper1,cur.fper2,cur.fper3,cur.fper4,cur.fper5,cur.fper6,cur.fper7,cur.fper8,cur.fper9])
			for mpers in mper:
				mpers=[mpers[i] for i in range(9) if mpers[i]!=0]
				for i in range(len(mpers)-1):
					if mpers[i]>mpers[i+1]:
						return 0  #reject
		return 1 #accept
	_order = 'parent_id desc,code'
	_constraints = [
		(check_start_days, _('Period Start Dates must be in ascending order'), ['mper1'])
	]
	_name = "hospital.lab.element"
	_order = "name asc"
	_columns = {
        'code' : fields.char ('Code', size=50,select=1),
		'category_id' : fields.many2one ('product.category','Exam Category', domain=[('contains_labexams', '=', "1")],select=1),
		'name' : fields.char('Name', size=128, select=1),
        'units' : fields.char('Units of Measure',size=128),
		'el_type' : fields.selection([
                                ('integer','Integer'),
                                ('float','Float'),
								('char','Text'),
                                ], 'Element Type',required=True,select=2),
		'autocalc' : fields.boolean('Auto Calculation'),
		'calcfunc' : fields.char('Auto Calculation Function',size=128,help='Enter an arithmetic function using Lab Elements Codes. eg WBC*NEU'),
        'mper1' : fields.integer ('mper1'),
        'mper1_low' : fields.float ('mper1_low',digits=(8,4)),
        'mper1_high' : fields.float ('mper1_high',digits=(8,4)),
        'mper2' : fields.integer ('mper2'),
        'mper2_low' : fields.float ('mper2_low',digits=(8,4)),
        'mper2_high' : fields.float ('mper2_high',digits=(8,4)),
        'mper3' : fields.integer ('mper3'),
        'mper3_low' : fields.float ('mper3_low',digits=(8,4)),
        'mper3_high' : fields.float ('mper3_high',digits=(8,4)),
        'mper4' : fields.integer ('mper4'),
        'mper4_low' : fields.float ('mper4_low',digits=(8,4)),
        'mper4_high' : fields.float ('mper4_high',digits=(8,4)),
        'mper5' : fields.integer ('mper5'),
        'mper5_low' : fields.float ('mper5_low',digits=(8,4)),
        'mper5_high' : fields.float ('mper5_high',digits=(8,4)),
        'mper6' : fields.integer ('mper6'),
        'mper6_low' : fields.float ('mper6_low',digits=(8,4)),
        'mper6_high' : fields.float ('mper6_high',digits=(8,4)),
        'mper7' : fields.integer ('mper7'),
        'mper7_low' : fields.float ('mper7_low',digits=(8,4)),
        'mper7_high' : fields.float ('mper7_high',digits=(8,4)),
        'mper8' : fields.integer ('mper8'),
        'mper8_low' : fields.float ('mper8_low',digits=(8,4)),
        'mper8_high' : fields.float ('mper8_high',digits=(8,4)),
        'mper9' : fields.integer ('mper9'),
        'mper9_low' : fields.float ('mper9_low',digits=(8,4)),
        'mper9_high' : fields.float ('mper9_high',digits=(8,4)),
        'mper10' : fields.integer ('mper10'),
        'mper10_low' : fields.float ('mper10_low',digits=(8,4)),
        'mper10_high' : fields.float ('mper10_high',digits=(8,4)),
        'fper1' : fields.integer ('fper1'),
        'fper1_low' : fields.float ('fper1_low',digits=(8,4)),
        'fper1_high' : fields.float ('fper1_high',digits=(8,4)),
        'fper2' : fields.integer ('fper2'),
        'fper2_low' : fields.float ('fper2_low',digits=(8,4)),
        'fper2_high' : fields.float ('fper2_high',digits=(8,4)),
        'fper3' : fields.integer ('fper3'),
        'fper3_low' : fields.float ('fper3_low',digits=(8,4)),
        'fper3_high' : fields.float ('fper3_high',digits=(8,4)),
        'fper4' : fields.integer ('fper4'),
        'fper4_low' : fields.float ('fper4_low',digits=(8,4)),
        'fper4_high' : fields.float ('fper4_high',digits=(8,4)),
        'fper5' : fields.integer ('fper5'),
        'fper5_low' : fields.float ('fper5_low',digits=(8,4)),
        'fper5_high' : fields.float ('fper5_high',digits=(8,4)),
        'fper6' : fields.integer ('fper6'),
        'fper6_low' : fields.float ('fper6_low',digits=(8,4)),
        'fper6_high' : fields.float ('fper6_high',digits=(8,4)),
        'fper7' : fields.integer ('fper7'),
        'fper7_low' : fields.float ('fper7_low',digits=(8,4)),
        'fper7_high' : fields.float ('fper7_high',digits=(8,4)),
        'fper8' : fields.integer ('fper8'),
        'fper8_low' : fields.float ('fper8_low',digits=(8,4)),
        'fper8_high' : fields.float ('fper8_high',digits=(8,4)),
        'fper9' : fields.integer ('fper9'),
        'fper9_low' : fields.float ('fper9_low',digits=(8,4)),
        'fper9_high' : fields.float ('fper9_high',digits=(8,4)),
        'fper10' : fields.integer ('fper10'),
        'fper10_low' : fields.float ('fper10_low',digits=(8,4)),
        'fper10_high' : fields.float ('fper10_high',digits=(8,4)),        
		}
lab_element ()






class vaccination (osv.osv):
	_name = "hospital.vaccination"
	_columns = {
		'name' : fields.many2one ('hospital.drug.substance','Vaccine Name', domain=[('is_vaccine', '=', "1")]),
		'date' : fields.datetime ('Date'),
		'dose' : fields.integer ('Dose Number'),
		'adverse_reactions' : fields.char('Adverse Reactions',size=256),
		'observations' : fields.char ('Observations', size=256),
		}
	_defaults = {
				'dose': lambda *a: 1
		}

vaccination ()

class drugs_recreational (osv.osv):
	_name="hospital.drugs_recreational"
	_columns = {
		'name': fields.char ('Name', size=128, help="Name of the drug"),
		'street_name': fields.char ('Street names', size=256, help="Common name of the drug in street jargon"),
		'toxicity' : fields.selection([
								('0','None'),
								('1','Low'),
								('2','High'),
								('3','Extreme'),
								], 'Toxicity', select=True),		
		'addiction_level' : fields.selection([
								('0','None'),
								('1','Low'),
								('2','High'),
								('3','Extreme'),
								], 'Addiction Level', select=True),		
		'legal_status' : fields.selection([
								('0','Legal'),
								('1','Illegal'),
								], 'Legal Status', select=True),

		'info' : fields.text ('Extra Info'),
		}

drugs_recreational ()

class family_code (osv.osv):
	_name = "hospital.family_code"
	_columns = {
		'name' :fields.char ('Name', size=128, help="Family code"),
		'members_ids' : fields.many2many ('res.partner', 'family_members_rel','family_id','members_id', 'Members'),
		'info' :fields.text ('Extra Information'),
		}

	_sql_constraints = [
			('code_uniq', 'unique (name)', 'The Family code name must be unique')]

family_code ()




class appointment (osv.osv):
	_name = "hospital.appointment"
	_columns = {
		'name' : fields.char ('ID',size=64),
		'patient' : fields.many2one ('res.partner','Patient', domain=[('is_patient', '=', "1")], help="Patient Name"),
		'appointment_date' : fields.datetime ('Date and Time'),
		'institution' : fields.many2one ('res.partner','Institution', domain=[('is_institution', '=', "1")],help="hospital Center"),
		'doctor' : fields.many2one ('hospital.physician','Doctor', help="Doctor Name"),
		'specialty' : fields.many2one ('hospital.specialty','Specialty', help="hospital Specialty / Sector"),
		'urgency' : fields.selection([
				('a','Normal'),
				('b','Urgent'),
				('c','hospital Emergency'),
				], 'Urgency Level'),

		'comments' : fields.text ('Comments'),

		}
	_order = "appointment_date desc"

	_defaults = {
			'urgency': lambda *a: 'a',
			#'name': lambda self, cr, uid, context=None: self.pool.get('ir.sequence').get(cr, uid, 'hospital.appointment'),
			}
	def create(self, cr, uid, vals, context={}):
		seq_number = self.pool.get('ir.sequence').get(cr, uid, 'hospital.appointment')
		vals['name'] = seq_number
		return super(appointment, self).create(cr, uid, vals, context)

	

	def name_get(self, cr, uid, ids, context={}):
		if not len(ids):
			return []
		res = []
		for r in self.read(cr, uid, ids, ['rec_name','appointment_date'],context):
			date = str(r['appointment_date'] or '')
			res.append((r['id'], date))
		return res


appointment ()



class ethnic_group (osv.osv):
	_name ="hospital.ethnicity"
	_columns = {
		'name' : fields.char ('Ethnic group',size=128),
		'code' : fields.char ('Code',size=64),
		}

ethnic_group ()

class occupation (osv.osv):
	_name = "hospital.occupation"
	_description = "Occupation / Job"
	_columns = {
		'name' : fields.char ('Occupation', size=256),
		'code' : fields.char ('Code', size=64),
		}
occupation ()

class hospital_dose (osv.osv):
	_name = "hospital.dose.unit"
	_columns = {
		'name' : fields.char ('Unit',size=32),
		'desc' : fields.char ('Description',size=64),
		}

hospital_dose ()





class patient_medication (osv.osv):
	def onchange_medicament_id(self, cr, uid, ids, medicament_id):
		v={}
		if medicament_id:
			tmp = self.pool.get('hospital.drug.medicament').read(cr, uid, medicament_id,['type_id', 'route_id'])
			print tmp
			v= {'route_id':tmp['route_id'][0], 'type_id':tmp['type_id'][0]}
		return {'value': v}
	_name = "hospital.patient.medication"
	_columns = {
		'patient_id' : fields.many2one ('hospital.patient', 'Patient'),
		'medicament_id' : fields.many2one ('hospital.drug.medicament','Medicament',help="Prescribed Medicament"),
		'prescription_id' : fields.char ('Prescription ID', size=64, help='Prescription ID. It is useful to group different medicaments in a single prescription'),
		'evaluation_id' : fields.many2one ('hospital.patient.evaluation','Evaluation',help='Select the evaluation if any'),
		'indication' : fields.many2one ('hospital.pathology','Indication'),
		'dose' : fields.integer ('Dose'),
		'dose_unit' : fields.many2one ('hospital.dose.unit','dose unit'),
		'type_id' : fields.related('medicament_id','type_id',type='many2one',relation='hospital.drug.type', readonly=True, string = 'Type'),
		'route_id' : fields.related('medicament_id','route_id',type='many2one',relation='hospital.drug.route',readonly=True, string = 'Administration Route'),
		'frequency' : fields.integer ('Frecuency #'),
		'frequency_unit' : fields.selection ([
			('s','seconds'),
			('m','minutes'),
			('h','hours'),
			('d','days'),
			('w','weeks'),
			('wr','when required'),
			], 'unit', select=True),

		'review' : fields.datetime ('Review'),
		'quantity' : fields.integer ('Quantity'),
		'refills' : fields.integer ('Refills #'),
		'allow_substitution' : fields.boolean('Allow substituion'),  
		'start_treatment' : fields.datetime ('Start of treatment'),
		'end_treatment' : fields.datetime ('End of treatment'),
		'discontinued' :  fields.boolean('Discontinued'),
		'course_completed' : fields.boolean('Course Completed'),
		'doctor' : fields.many2one('hospital.physician','Doctor', help="Doctor who prescribed the medicament"),
		'is_active' : fields.boolean('Active',help="Check this option if the patient is currently taking the medication"),
		'discontinued_reason' : fields.char ('Reason for discontinuation', size=128, help="Short description for discontinuing the treatment"),
		'adverse_reaction' : fields.text ('Adverse Reactions',help="Specific side effects or adverse reactions that the patient experienced"),
		'notes' : fields.text ('Extra Info'),
		}
	_defaults = {
				'frequency_unit': lambda *a: 'h',
				'quantity': lambda *a: 1
		}

	
patient_medication ()

class patient_disease_info (osv.osv):
	def _get_date(self, cr, uid, ids, name, arg, context={}):
		result={}
		for disease in self.browse(cr, uid, ids, context=context):
			result[disease.id] = disease.diagnosed_year if disease.diagnosed_date==False else time.strftime('%d/%m/%Y', time.strptime(disease.diagnosed_date,   '%Y-%m-%d'))
		return result
	def onchange_name_icd(self, cr, uid, ids, nameicd_id):
		v= {'name': self.pool.get('hospital.pathology').read(cr, uid, nameicd_id)['complete_name']} if nameicd_id else {}
		return {'value': v}
	_name = "hospital.patient.disease"
	_description = "Disease info"
	_columns = {
		'nameicd_id' : fields.many2one ('hospital.pathology','Hospital Condition', help="Disease"),
		'name' : fields.char('Hospital Condition (free text)', required="True", size=256),
		'doctor' : fields.many2one('hospital.physician','Doctor', help="Doctor who treated or diagnosed the patient"),
		'diagnosed_date': fields.date ('Date of Diagnosis'),
		'diagnosed_year' : fields.integer('Year of Diagnosis', help='If the exactly date is not known'),
		'tree_date': fields.function(_get_date, method=True, type='char', string='Date of Diagnosis'),
		'age': fields.char ('Age when diagnosed',size=3,help='Patient age at the moment of the diagnosis. Can be estimative'),
		'pregnancy_warning': fields.boolean ('Pregnancy warning'),
		'weeks_of_pregnancy' : fields.integer ('Contracted in pregnancy week #'),
		'description' : fields.char ('Description', size=128),
		'is_on_treatment' : fields.boolean ('Currently on Treatment'),
		'pcs_code' : fields.many2one ('hospital.procedure','ICD-10-PCS Code', help="ICD-10-PCS Code 7-character string"),
		'treatment_description' : fields.char ('Treatment Description',size=128),
		'date_start_treatment' : fields.date ('Start of treatment'),
		'date_stop_treatment' : fields.date ('End of treatment'),
		'status' : fields.selection ([
			('c','chronic'),
			('s','status quo'),
			('h','healed'),
			('i','improving'),
			('w','worsening'),
			], 'Status of the disease', select=True),
		'extra_info' : fields.text ('Extra Info'),
		}

patient_disease_info ()


class surgery (osv.osv):
	def onchange_pathology_icd(self, cr, uid, ids, pathology_icd_id):
		v= { 'pathology_text': self.pool.get('hospital.pathology').read(cr, uid, pathology_icd_id)['complete_name']} if pathology_icd_id else {}
		return {'value': v}
	def onchange_name_icd(self, cr, uid, ids, name_icd_id):
		v= { 'name': self.pool.get('hospital.procedure').read(cr, uid, name_icd_id)['description']} if name_icd_id else {}
		return {'value': v}
	_name = "hospital.surgery"
	_description = "Surgery"
	_columns = {
		'name_icdpcs' : fields.many2one ('hospital.procedure','ICD-10-PCS Code', help="ICD-10-PCS Code 7-character string"),
		'name' : fields.char('Surgery Title',size=256, required=1),
		'pathology_icd_id' : fields.many2one ('hospital.pathology','Base condition ICD-10 Code', help="Base Condition / Reason"),
		'pathology_text' : fields.char('Base condition (free text)',size=512),
		'classification' : fields.selection ([
				('o','Optional'),
				('r','Required'),
				('u','Urgent'),
								], 'Surgery Classification', select=True),
		'surgeon' : fields.many2one('hospital.physician','Surgeon', help="Surgeon who did the procedure"),
		'date': fields.datetime ('Date of the surgery'),
		'age': fields.char ('Patient age',size=3,help='Patient age at the moment of the surgery. Can be estimative'),
		'extra_info' : fields.text ('Extra Info'),
		}

surgery ()


class perinatal_monitor (osv.osv):
	_name = "hospital.perinatal.monitor"
	_description = "Perinatal monitor"
	_columns = {
		'name' : fields.char ('Internal code',size=128),
		'date' : fields.datetime ('Date and Time'),
		'systolic' : fields.integer ('Systolic Pressure'),
		'diastolic' : fields.integer ('Diastolic Pressure'),
		'contractions' : fields.integer ('Contractions'),
		'frequency' : fields.integer ('Mother\'s Heart Frequency'),
		'dilation' : fields.integer ('Cervix dilation'),
		'f_frequency' : fields.integer ('Fetus Heart Frequency'),
				'meconium' : fields.boolean('Meconium'),
		'bleeding' : fields.boolean ('Bleeding'),
		'fundal_height' : fields.integer ('Fundal Height'),
		'fetus_position' : fields.selection ([
			('n','Correct'),
			('o', 'Occiput / Cephalic Posterior'),
			('fb', 'Frank Breech'),
			('cb', 'Complete Breech'),
			('t', 'Transverse Lie'),
			('t', 'Footling Breech'),
			], 'Fetus Position', select=True),

		}

perinatal_monitor ()

class newborn (osv.osv):
	_name = "hospital.newborn"
	_description = "newborn information"
	_columns = {
		'name' : fields.char ('Baby\'s name',size=128),
		'code' : fields.char ('Newborn ID', size=64,required=True),
				'birth_date' : fields.datetime('Date of Birth', required=True),
		'photo' : fields.binary ('Picture'),
		'sex' : fields.selection([
								('m','Male'),
								('f','Female'),
								], 'Sex', select=True, required=True),
		'cephalic_perimeter' : fields.integer ('Cephalic Perimeter'),
		'length' : fields.integer ('Length'),
		'weight' : fields.integer ('Weight'),
				'apgar1' : fields.integer('APGAR 1st minute'),
				'apgar5' : fields.integer('APGAR 5th minute'),
		'meconium': fields.boolean ('Meconium'),
		'congenital_diseases' : fields.many2many ('hospital.patient.disease', 'newborn_disease_rel','patient_id','congenital_id', 'Congenital diseases'),
		'reanimation_stimulation' :fields.boolean ('Stimulation'),
		'reanimation_aspiration' :fields.boolean ('Aspiration'),
		'reanimation_intubation' :fields.boolean ('Intubation'),
		'reanimation_mask' :fields.boolean ('Mask'),
		'reanimation_oxygen' :fields.boolean ('Oxygen'),
		'test_vdrl' : fields.boolean ('VDRL'),
		'test_toxo' : fields.boolean ('Toxoplasmosis'),
		'test_chagas' : fields.boolean ('Chagas'),
		'test_billirubin' : fields.boolean ('Billirubin'),
		'test_audition' : fields.boolean ('Audition'),
		'test_metabolic' : fields.boolean ('The metabolic / genetic check ("heel stick") has been done', help="Fenilketonuria, Congenital Hypothyroidism, Quistic Fibrosis, Galactosemia"),
		'medication' : fields.many2many('hospital.drug.medicament', 'newborn_labor_rel','medicament_id','patient_id','Medicaments and anesthesics'),
		'responsible' : fields.many2one('hospital.physician','Doctor in charge',help="Signed by the health professional"), 
		'dismissed' : fields.datetime('Dismissed from hospital'),
		'bd' : fields.boolean ('Born dead'),
		'died_at_delivery' : fields.boolean ('Died at delivery room'),
		'died_at_the_hospital' : fields.boolean ('Died at the hospital'),
		'died_being_transferred' : fields.boolean ('Died being transferred',help="The baby died being transferred to another health institution"),
		'tod' : fields.datetime('Time of Death'),
		'cod' : fields.many2one('hospital.pathology', 'Cause of death'),
		'notes' : fields.text ('Notes'),
		
	}

	_sql_constraints = [
			('code_uniq', 'unique (code)', 'The newborn ID must be unique')]


newborn ()





class puerperium_monitor (osv.osv):
	_name = "hospital.puerperium.monitor"
	_description = "Puerperium Monitor"
	_columns = {
		'name' : fields.char ('Internal code',size=64),
		'date' : fields.datetime ('Date and Time', required=True),
		'systolic' : fields.integer ('Systolic Pressure'),
		'diastolic' : fields.integer ('Diastolic Pressure'),
		'frequency' : fields.integer ('Heart Frequency'),
		'lochia_amount' : fields.selection([
								('n','normal'),
								('e','abundant'),
								('h','hemorrhage'),
								], 'Lochia amount', select=True),

		'lochia_color' : fields.selection([
								('r','rubra'),
								('s','serosa'),
								('a','alba'),
								], 'Lochia color', select=True),

		'lochia_odor' : fields.selection([
								('n','normal'),
								('o','offensive'),
								], 'Lochia odor', select=True),

		'uterus_involution' : fields.integer ('Fundal Height', help="Distance between the symphysis pubis and the uterine fundus (S-FD) in cm"),
		'temperature' : fields.float ('Temperature'),
		}

puerperium_monitor ()



class perinatal (osv.osv):
	_name = "hospital.perinatal"
	_description = "perinatal information"
	_columns = {
		'name' : fields.char ('code',size=128),
				'gravida_number' : fields.integer('Gravida #'),
				'abortion' : fields.boolean('Abortion'),
		'admission_date' : fields.datetime ('Admission date',help="Date when she was admitted to give birth"),
		'prenatal_evaluations' : fields.integer ('Prenatal evaluations',help="Number of visits to the doctor during pregnancy"),
		'start_labor_mode' : fields.selection ([
								('n','Normal'),
								('i','Induced'),
								('c','c-section'),
								], 'Labor mode', select=True),
		'gestational_weeks' : fields.integer ('Gestational weeks'),
		'gestational_days' : fields.integer ('Gestational days'),
		'fetus_presentation' : fields.selection ([
			('n','Correct'),
			('o', 'Occiput / Cephalic Posterior'),
			('fb', 'Frank Breech'),
			('cb', 'Complete Breech'),
			('t', 'Transverse Lie'),
			('t', 'Footling Breech'),
			], 'Fetus Presentation', select=True),
		'placenta_incomplete' : fields.boolean('Incomplete Placenta'),
		'placenta_retained' : fields.boolean('Retained Placenta'),
		'episiotomy' : fields.boolean('Episiotomy'),
		'vaginal_tearing' : fields.boolean('Vaginal tearing'),
				'forceps' : fields.boolean('Use of forceps'),
		'monitoring' : fields.many2many('hospital.perinatal.monitor', 'patient_perinatal_monitor_rel','patient_id','monitor_ids','Monitors'),
		'newborn' : fields.many2many('hospital.newborn', 'patient_newborn_rel','patient_id','newborn_ids','Newborn info'),
		'puerperium_monitor' : fields.many2many('hospital.puerperium.monitor', 'patient_puerperium_monitor_rel','patient_id','puerperium_ids','Puerperium monitor'),
		'medication' : fields.many2many('hospital.drug.medicament', 'patient_labor_rel','medicament_id','patient_id','Medicaments and anesthesics'),
		'dismissed' : fields.datetime('Dismissed from hospital'),
		'died_at_delivery' : fields.boolean ('Died at delivery room'),
		'died_at_the_hospital' : fields.boolean ('Died at the hospital'),
		'died_being_transferred' : fields.boolean ('Died being transferred',help="The mother died being transferred to another health institution"),
		'notes' : fields.text ('Notes'),
	}

perinatal ()



class genetic_risk (osv.osv):
	_name= "hospital.genetic.risk"
	_description= "Genetic Risks"
	_columns = {
		'name' : fields.char ('Official Symbol', size=16),
		'long_name' : fields.char ('Official Long Name', size=256),
		'gene_id' : fields.char ('Gene ID', size=8, help="default code from NCBI Entrez database."),
		'chromosome' : fields.char ('Affected Chromosome', size=2, help="Name of the affected chromosome"),
		'location' : fields.char ('Location', size=32, help="Locus of the chromosome"),
		'dominance' : fields.selection([
								('d','dominant'),
								('r','recessive'),
								], 'Dominance', select=True),		
		'info' : fields.text ('Information', size=128, help="Name of the protein(s) affected"),
	}


	def name_search(self, cr, uid, name, args=[], operator='ilike', context={}, limit=80):
			args2 = args[:]
			if name:
					args += [('name', operator, name)]
					args2 += [('long_name', operator, name)]
			ids = self.search(cr, uid, args, limit=limit)
			ids += self.search(cr, uid, args2, limit=limit)
			res = self.name_get(cr, uid, ids, context)
			return res

genetic_risk ()




class patient_allergy (osv.osv):
	def onchange_name_icd(self, cr, uid, ids, nameicd_id):
		v= {'name': self.pool.get('hospital.pathology').read(cr, uid, nameicd_id)['complete_name']} if nameicd_id else {}
		return {'value': v}
	_name = "hospital.patient.allergy"
	_description = "Patient Allergies"
	_columns = {
		'patient_id' : fields.many2one ('hospital.patient', 'Patient'),
		'nameicd_id' : fields.many2one ('hospital.pathology', 'Allergy ICD-10 Code'),
		'name' : fields.char('Allergy (free text)',size=256, required=True),
		'clinical' : fields.char('Clinical Conditions',size=256),
		'treatment' : fields.char('Treatment',size=256),
		'first_event' : fields.date('First Event'),
		'events_num' : fields.integer('Number of Events'),
		'extra_info': fields.text('Extra Info'),
		}
patient_allergy ()




class family_diseases (osv.osv):
	def onchange_name_icd(self, cr, uid, ids, nameicd_id):
		v= {'name': self.pool.get('hospital.pathology').read(cr, uid, nameicd_id)['complete_name']} if nameicd_id else {}
		return {'value': v}
	_name = "hospital.family.diseases"
	_description = "Family Diseases"
	_columns = {
		#'patient_id' : fields.many2one ('hospital.patient', 'Patient ID'),
		'nameicd_id' : fields.many2one ('hospital.pathology', 'Disease ICD-10 Code'),
		'name' : fields.char('Disease (free text)',size=256, required=True),
		'matpat' : fields.selection([
								('m','Maternal'),
								('f','Paternal'),
								], 'Maternal/Paternal', select=True),
		'relative' : fields.selection([
								('m','Mother'),
								('a','Father'),
								('b','Brother'),
								('s','Sister'),
								('au','Aunt'),
								('u','Uncle'),
								('ne','Nephew'),
								('ni','Niece'),
								('gf','Grandfather'),
								('gm','Grandmother'),
								('c','Cousin'),
								], 'Relative', help="First degree = siblings, mother and father; second degree = Uncles, nephews and Nieces; third degree = Grandparents and cousins", select=True),
							}
family_diseases ()

	
class patient_data (osv.osv):
	def _labtest_compute(self, cr, uid, data, context):
		if data:
			temp = []
			labtest_id=0
			print data
			if data['form'].has_key('image'): #edw mpainei mono otan kanei fill test me image/other
				create_dict = {
								   'labtemplate_id': data['form']['labtemplate_id'],
								   'patient_id': data['id'],
								   'date_request' : data['form']['date_request'],
								   'image' : data['form']['image'],
								   }
				if data['form'].has_key('file') and data['form']['file']:
					create_dict['file'] = data['form']['file']
				labtest_id=self.pool.get('hospital.lab.test').create(cr,uid,create_dict,context)
				self.pool.get('hospital.lab.test').case_order(cr, uid, [labtest_id])
				self.pool.get('hospital.lab.test').case_result(cr, uid, [labtest_id],data['form']['date_analysis'])
			else:
				addelements= False if len(data['form'])==2 else True #elegxw an einai apla order test kai oxi fill test
				#print addelements
				for x in data['form']:
					if x.startswith("lab_form") and data['form'][x] != 0 :
						temp.append(data['form'][x])
				#print temp
				create_dict = {
								   'labtemplate_id': data['form']['labtemplate_id'],
								   'patient_id':data['id'],
								   'date_request' : data['form']['date_request'],
								   }
				
				labtest_id=self.pool.get('hospital.lab.test').create(cr,uid,create_dict,context)
				#print 'labtest_id='+str(labtest_id)
				if not addelements: self.pool.get('hospital.lab.test').case_order(cr, uid, [labtest_id])
				
				if addelements:
					i=10
					custom_dict=[{},{},{},{}] # Dhmiourgw enan dict me ta 4 custom stoixeia. Kata ti diarkeia toy loop ftiaxnw to array
					for (key,value) in data['form'].items():
						if 'lab_form' in key:
							cr_dict = {
									'labtest_id' : labtest_id,
									'sequence' : data['cache'][int(key.replace('lab_form',''))],
									'labelement_id' : int(key.replace('lab_form','')),
									'value' : value,
								}
							self.pool.get('hospital.lab.line').create(cr,uid,cr_dict,context)
							i+=10
						if key in ('extra0','extra1','extra2','extra3') and value!=0: #extra custom labs labels
							extra_id=int(key.replace('extra',''))
							custom_dict[extra_id]['labtest_id'] = labtest_id
							custom_dict[extra_id]['sequence'] = (extra_id+1)*1000
							custom_dict[extra_id]['labelement_id'] = value
						if 'extraval' in key and value!=0:#extra custom labs values
							extra_id=int(key.replace('extraval','')) #0,1,2,3
							#vriskw ton typo toy antistoixou labelement
							obj = self.pool.get('hospital.lab.element')
							el_id = obj.search(cr, uid, [('id', '=', custom_dict[extra_id]['labelement_id'])])
							res = obj.read(cr, uid, el_id, ['el_type'], context)
							#print res,custom_dict[extra_id]['labelement_id']
							el_type=res[0]['el_type']
							val=""
							if el_type=='integer': 
								try:val=int(float(value))
								except:pass
							elif el_type=='float': 
								try:val=float(value.replace(',','.'))
								except:pass
							else: val=value
							custom_dict[extra_id]['value'] = str(val)
					#print custom_dict
					for cur in custom_dict:
						if 'labelement_id' in cur:
							if cur['labelement_id']==False: continue
							self.pool.get('hospital.lab.line').create(cr,uid,cur,context)
					self.pool.get('hospital.lab.test').case_result(cr, uid, [labtest_id],data['form']['date_analysis'])
		return {}
#	Automatically assign the family code
	def onchange_partnerid (self, cr, uid, ids, partner):
		family_code_id = ""
		v={}
		if partner:
 			cr.execute ('select family_id from family_members_rel where members_id=%s limit 1',(partner,))
			try:
				family_code_id = str(cr.fetchone()[0])
			except:
				family_code_id = ""
		obj = self.pool.get('res.partner')
		res = obj.read(cr, uid, partner)
		#print res
		v['odos']=res['address']
		v['adt']=res['adt']
		v['insurance']=res['insurance']
		v['family_code']=family_code_id
		
		return {'value': v}	

	
		
	def _patient_age(self, cr, uid, ids, name, arg, context={}):
		def compute_age_from_dates (patient_dob):
			now=DateTime.now()
			if (patient_dob):
				dob=DateTime.strptime(patient_dob,'%Y-%m-%d')
				delta=DateTime.Age (now, dob)
				years_months_days = str(delta.years) +" "+ str(delta.months) +" "+" "+ str(delta.days)
			else:
				years_months_days = _("No DoB !")
			
 
			return years_months_days
		result={}
		for patient_data in self.browse(cr, uid, ids, context=context):
			result[patient_data.id] = compute_age_from_dates (patient_data.dob)
		return result
	_rec_name = 'last_name'
	_name = "hospital.patient"
	_description = "Patient related information"
	_inherits={'res.partner':'partner_id'}
	_columns = {
		'partner_id' : fields.many2one('res.partner','Patient',domain=[('is_patient', '=', True)], help="Patient"),
		'family_code' : fields.many2one ('hospital.family_code','Family',help="Family Code"),
		'photo' : fields.binary ('Picture'),
		'dob' : fields.date ('Date of Birth'),
		'origin' : fields.many2one('res.country', 'Country of Origin'),
		'age' : fields.function(_patient_age, method=True, type='char', string='Patient Age'),
		'sex' : fields.selection([
								('m','Male'),
								('f','Female'),
								], 'Sex', select=True),
		'marital_status' : fields.selection([
								('s','Single'),
								('m','Married'),
				('w','Widowed'),
				('d','Divorced'),
				('x','Separated'),
								], 'Marital Status'),
		'blood_type' : fields.selection([
				('a','A'),
				('b','B'),
				('ab','AB'),
				('o','O'),
				], 'Blood Type'),
		'rh' : fields.selection([
				('+','+'),
				('-','-'),
				], 'Rh'),

# lifestyle section

		'excercise' : fields.boolean ('Excersise'),
		'excercise_minutes_day' : fields.integer ('Minutes / day'),
		'number_of_meals' : fields.integer ('Meals per day'),
		'eats_alone' : fields.boolean ('Eats alone',help="Check this box if the patient eats by him / herself."),
		'salt' : fields.boolean ('Salt',help="Check if patient consumes salt with the food"),
		'coffee' : fields.boolean ('Coffee'),
		'coffee_cups' : fields.integer ('Cups per day',help="Number of cup of coffee a day"),
		'soft_drinks' : fields.boolean ('Soft drinks (sugar)',help="Check if the patient consumes soft drinks with sugar"),
		'smoking' : fields.boolean ('Smokes'),
		'smoking_number' : fields.integer ('Cigarretes a day'),
		'ex_smoker' : fields.boolean ('Ex-smoker'),
		'second_hand_smoker' : fields.boolean ('Passive smoker', help="Check it the patient is a passive / second-hand smoker"),
		'age_start_smoking' : fields.integer ('Age started to smoke'),
		'alcohol' : fields.boolean ('Drinks Alcohol'),
		'alcohol_beer_number' : fields.integer ('Beer / day'),
		'alcohol_wine_number' : fields.integer ('Wine / day'),
		'alcohol_liquor_number' : fields.integer ('Drinks(>40%vol) / day', help="Eg. Whisky, Vodka, Tequila, Liquor etc"),
		'drug_usage' : fields.boolean ('Drug Habits'),
		'drugs' : fields.many2many ('hospital.drugs_recreational','patient_drugs_recreational_rel','patient_id','drugs_recreational_id','Drugs', help="Name of drugs that the patient consumes"),  
		'lifestyle_info' :fields.text ('Extra Information'),

# End of lifestyle section


# Socioeconomics

		'ses': fields.selection ([
			('0','Lower'),
			('1','Lower-middle'),
			('2','Middle'),
			('3','Middle-upper'),
			('4','Higher'),
			], 'Socioeconomics',help="SES - Socioeconomic Status"),


		'education': fields.selection ([
			('0','None'),
			('1','Incomplete Primary School'),
			('2','Primary School'),
			('3','Incomplete Secondary School'),
			('4','Secondary School'),
			('5','University'),
			], 'Education Level',help="Education Level"),


		'hostile_area' : fields.boolean ('Hostile Area', help="Check this box if the patient lives in a zone of high hostility (eg, war)"),


		'single_parent': fields.boolean ('Single parent family'),
		'family_children' : fields.integer ('Children(s)'),

		'ses_notes' : fields.text ("Extra info"),

		'fam_apgar_help': fields.selection ([
			('0','None'),
			('1','Moderately'),
			('2','Very much'),
			], 'Help from family',help="Is the patient satisfied with the level of help coming from the family when there is a problem ?"),


		'fam_apgar_discussion': fields.selection ([
			('0','None'),
			('1','Moderately'),
			('2','Very much'),
			], 'Family discussions on problems',help="Is the patient satisfied with the level talking over the problems as family ?"),
		
		'fam_apgar_decisions': fields.selection ([
			('0','None'),
			('1','Moderately'),
			('2','Very much'),
			], 'Family decision making',help="Is the patient satisfied with the level of making important decisions as a group ?"),

		'fam_apgar_timesharing': fields.selection ([
			('0','None'),
			('1','Moderately'),
			('2','Very much'),
			], 'Family time sharing',help="Is the patient satisfied with the level of time that they spend together ?"),

		'fam_apgar_affection': fields.selection ([
			('0','None'),
			('1','Moderately'),
			('2','Very much'),
			], 'Family affection',help="Is the patient satisfied with the level of affection coming from the family ?"),


		'sexual_preferences' : fields.selection([
								('h','Heterosexual'),
								('g','Homosexual'),
				('b','Bisexual'),
				('t','Transexual'),
								], 'Sexual Preferences'),

		'sexual_practices' : fields.selection([
								('s','Safe / Protected sex'),
								('r','Risky / Unprotected sex'),
				], 'Sexual Practices'),

		'sexual_partners': fields.selection([
				('m','Monogamous'),
				('t','Poligamous'),
								], 'Sexual Partners'),

		'first_sexual_encounter': fields.integer ('Age first sexual encounter'),

		'anticonceptive': fields.selection ([
			('0','None'),
			('1','Pill / Minipill'),
			('2','Male condom'),
			('3','Vasectomy'),
			('4','Female sterilisation'),
			('5','Intra-uterine device'),
			('6','Withdrawal method'),
			('7','Fertility cycle awareness'),
			('8','Contraceptive injection'),
			('9','Skin Patch'),
			('10','Female condom'),
			], 'Anticonceptive Method'),

		'income' : fields.selection([
								('h','High'),
								('m','Medium / Average'),
				('l','Low'),
								], 'Income', select=True),


		'currently_pregnant' : fields.boolean ('Currently Pregnant'),
		'fertile' : fields.boolean ('Fertile', help="Check if patient is in fertile age"),
		'menarche' : fields.integer ('Menarche age'),
		'menopausal' : fields.boolean ('Menopausal'),
		'menopause' : fields.integer ('Menopause age'),
		'gravida' : fields.integer ('Gravida',help="Number of pregnancies"),
		'premature' : fields.integer ('Premature',help="Premature Deliveries"),
		'abortions' : fields.integer ('Abortions'),
		'full_term' : fields.integer ('Full Term', help="Full term pregnancies"),
		'gpa' :fields.char ('GPA',size=32,help="Gravida, Para, Abortus Notation. For example G4P3A1 : 4 Pregnancies, 3 viable and 1 abortion"),
		'born_alive' : fields.integer ('Born Alive'),
		'deaths_1st_week' : fields.integer ('Deceased during 1st week',help="Number of babies that die in the first week"),
		'deaths_2nd_week' : fields.integer ('Deceased after 2nd week',help="Number of babies that die after the second week"),
		'perinatal' : fields.many2many ('hospital.perinatal', 'patient_perinatal_rel','patient_id','perinatal_id', 'Perinatal Info'),
		'occupation' : fields.many2one ('hospital.occupation','Occupation'),
		'works_at_home' : fields.boolean ('Works at home',help="Check if the patient works at his / her house"),
		'hours_outside' : fields.integer ('Hours outside home',help="Number of hours a day the patient spend outside the house"),
		'ethnic_group' : fields.many2one ('hospital.ethnicity','Ethnic group'),
		'allergy_info' : fields.text ('Allergy Info'),
		'allergies': fields.one2many ('hospital.patient.allergy','patient_id',"Allergies"),
		'vaccinations': fields.many2many ('hospital.vaccination','patient_hospital_vaccination','patient_id','vaccination_id',"Vaccinations"),
		'medications' : fields.one2many('hospital.patient.medication','patient_id','Medications'),
		'genetic_risks' : fields.many2many('hospital.genetic.risk','patient_genetic_risks_rel','patient_id','genetic_risk_id','Genetic Risks'),
		'family_history' : fields.many2many ('hospital.family.diseases', 'patient_familyhist_rel','patient_id','pathology_id', 'Family History'),
		'surgery' : fields.many2many ('hospital.surgery', 'patient_surgery_rel','patient_id','surgery_id', 'Surgeries'),
		'disease' : fields.many2many ('hospital.patient.disease', 'patient_disease_rel','patient_id','disease_id', 'Diseases'),
		'labtest_ids' : fields.one2many('hospital.lab.test','patient_id','Tests'),
		'evaluation_ids' : fields.one2many ('hospital.patient.evaluation','name','Evaluation'),
		'notes' : fields.text ('Notes'),
		'deceased' : fields.boolean ('Deceased',help="Mark if the patient has died"),
		'dod' : fields.datetime ('Date of Death'),
		'cod' : fields.many2one ('hospital.pathology', 'Cause of Death'),

	}

patient_data ()



class hospital_patient_evaluation (osv.osv):

	_name = "hospital.patient.evaluation"
	_description = "evaluation"
	_columns = {
		'name' : fields.many2one ('hospital.patient','Patient', readonly=True),
		'evaluation_appointment' : fields.many2one ('hospital.appointment','Evaluation Date'),
		'evaluation_starttime' : fields.datetime ('Start of Evaluation'),
		'evaluation_endtime' : fields.datetime ('End of Evaluation'),
		'next_evaluation' : fields.many2one ('hospital.appointment','Next evaluation'),
		'user_id' : fields.many2one ('res.users','Doctor', readonly=True),
		'derived_from' : fields.many2one('hospital.physician','Derived from Doctor',help="Physician who escalated / derived the case"), 
		'derived_to' : fields.many2one('hospital.physician','Derived to Doctor',help="Physician to whom escalate / derive the case"), 
		'evaluation_type' : fields.selection([
								('a','Ambulatory'),
								('e','Emergengy'),
								('i','Hospitalary'),
								('pa','Pre-arraganged appointment'),
								('pc','Periodic control'),
					('p','Phone call'),
								], 'Evaluation Type', select=True),
		'signs' : fields.text ('Signs'),
		'symptoms' : fields.text ('Symptoms'),
		'chief_complaint' : fields.char ('Chief Complaint', size=128,help='Chief Complaint'),
		'notes_complaint' : fields.text ('Complaint details'),
		'glycemia' : fields.float('Glycemia'),
		'cholesterol_total' : fields.float ('Cholesterol'),
		'hdl' : fields.integer ('HDL'),
		'ldl' : fields.integer ('LDL'),
		'tag' : fields.integer ('TAGs',help="Triacylglycerols (triglicerides) level"),
		'systolic' : fields.integer('Systolic Pressure'),
		'diastolic' : fields.integer('Diastolic Pressure'),
		'bpm' : fields.integer ('Heart Rate',help="Heart rated expressed in beats per minute"),
		'temperature' : fields.float('temperature (celsius)'),
		'weight' : fields.float('weight (kg)'),
		'height' : fields.float('height (cm)'),
		'bmi' : fields.float('Body Mass Index'),
		'abdominal_circ' : fields.float('Abdominal Circumference'),
		'loc' : fields.integer('Level of Consciousness', help="Level of Consciousness - on Glasgow Coma Scale :  1=coma - 15=normal"),
		'loc_eyes' : fields.integer('Level of Consciousness - Eyes', help="Eyes Response - Glasgow Coma Scale - 1 to 4"),
		'loc_verbal' : fields.integer('Level of Consciousness - Verbal', help="Eyes Response - Glasgow Coma Scale - 1 to 5"),
		'loc_motor' : fields.integer('Level of Consciousness - Motor', help="Eyes Response - Glasgow Coma Scale - 1 to 6"),		
		'mood' : fields.integer ('Mood',help="1=very angry - 5=very happy"),
		'diagnosis_text' : fields.char ('Diagnosis',size=256),
		'diagnosis' : fields.many2one ('hospital.pathology','Diagnosis ICD-10 Code:'),
		'diagnosis_info' : fields.text('Diagnosis Info'),
		'directions' : fields.text('hospital Directions'),
		'actions' : fields.many2many('hospital.procedure', 'patient_procedures_rel','patient_id','procedure_ids','Procedures'),
		'medication_ids' : fields.one2many('hospital.patient.medication','evaluation_id','Medications'),
		'notes' : fields.text ('Notes'),
	}

	_defaults = {
				'loc_eyes': lambda *a: 4,
				'loc_verbal': lambda *a: 5,
				'loc_motor': lambda *a: 6,
		'evaluation_type': lambda *a: 'pa',
		'user_id': lambda obj, cr, uid, context: uid
		}


	def onchange_height_weight (self, cr, uid, ids, height, weight):
		if height:
			v = {'bmi':weight/((height/100)**2)}
		else:
			v = {'bmi':0}

		return {'value': v}	
				
	def onchange_loc (self, cr, uid, ids, loc_motor, loc_eyes, loc_verbal):
		v = {'loc':loc_motor + loc_eyes + loc_verbal}
		return {'value': v}	


hospital_patient_evaluation ()

# HEALTH CENTER / HOSPITAL INFRASTRUCTURE

class hospital_building (osv.osv):
	_name = "hospital.hospital.building"
	_columns = {
		'name' : fields.char ('Name', size=128, help="Name of the building within the institution"),
		'institution' : fields.many2one ('res.partner','Institution', domain=[('is_institution', '=', "1")],help="hospital Center"),
		'code' : fields.char ('Code', size=64),
		'extra_info' : fields.text ('Extra Info'),
		}
hospital_building ()

class hospital_unit (osv.osv):
	_name = "hospital.hospital.unit"
	_columns = {
		'name' : fields.char ('Name', size=128, help="Name of the unit, eg Neonatal, Intensive Care, ..."),
		'institution' : fields.many2one ('res.partner','Institution', domain=[('is_institution', '=', "1")],help="hospital Center"),
		'code' : fields.char ('Code', size=64),
		'extra_info' : fields.text ('Extra Info'),
		}
hospital_unit ()

class hospital_ward (osv.osv):
	_name = "hospital.hospital.ward"
	_columns = {
		'name' : fields.char ('Name', size=128, help="Ward code"),
		'institution' : fields.many2one ('res.partner','Institution', domain=[('is_institution', '=', "1")],help="hospital Center"),
		'building' : fields.many2one ('hospital.hospital.building','Building'),
		'floor' : fields.integer ('Floor Number'),
		'unit' : fields.many2one ('hospital.hospital.unit','Unit'),
		'private' : fields.boolean ('Private',help="Check this option for private wards"),
		'number_of_beds' : fields.integer ('Number of beds',help="Number of patients per ward"),
		'telephone' : fields.boolean ('Telephone access'),
		'ac' : fields.boolean ('Air Conditioning'),
		'private_bathroom' : fields.boolean ('Private Bathroom'),
		'guest_sofa' : fields.boolean ('Guest sofa-bed'),
		'tv' : fields.boolean ('Television'),
		'internet' : fields.boolean ('Internet Access'),
		'refrigerator' : fields.boolean ('Refrigetator'),
		'microwave' : fields.boolean ('Microwave'),
		'gender' : fields.selection ((('men','Men Ward'),('women','Women Ward'),('unisex','Unisex')),'Gender', required=True),
		'state': fields.selection((('beds_available','Beds available'),('full','Full'),('bio_hazard','Biological Hazard'),('na','Not available')),'Status', required=True),
		#'bed_ids' : fields.one2many('hospital.hospital.bed','ward','Beds'),
		'extra_info' : fields.text ('Extra Info'),
		}

	_defaults = {
                'number_of_beds': lambda *a: 1,
		}

hospital_ward ()

class hospital_bed (osv.osv):
	_name = "hospital.hospital.bed"
	_columns = {
		'name' : fields.char ('Number',size=128, help="Bed Number / Code"),
		'category' : fields.many2one ('product.product','Category', domain=[('is_bed', '=', "1")], help="Bed type"),
		'ward' : fields.many2one ('hospital.hospital.ward','Ward'),
		'bed_type' : fields.selection((('gatch','Gatch Bed'),('electric','Electric'),('stretcher','Stretcher'),('low','Low Bed'),('low_air_loss','Low Air Loss'),('circo_electric','Circo Electric'),('clinitron','Clinitron')),'Bed Type', required=True),
		'telephone_number' : fields.char ('Telephone Number',size=128, help="Telephone number / Extension"),
		'extra_info' : fields.text ('Extra Info'),
		'state': fields.selection((('free','Free'),('reserved','Reserved'),('occupied','Occupied'),('na','Not available')),'Status', required=True),
		}

	_defaults = {
                'bed_type': lambda *a: 'gatch',
		}

hospital_bed ()



